
# Contribute to Donkey
Donkey is an open source project to help accelerate the development of 
self driving autos. 

###Guiding Development Principles

* **Modularity**: A self driving system is composed of standalone, 
independently configurable components that can be combined to make a car.
* **Minimalism**: Each component should be kept short (<100 lines of code). 
Each piece of code should be transparent upon first reading. No black magic, 
it slows the speed of innovation. 
* **Extensibility**: New components should be simple to create by following a 
template. 
* **Python**: Keep it simple. 

***These guidelines are nearly copied from [Keras](http://keras.io) because they are so good*** 



### Add a part. 
Are you a hardware specialist that can write a donkey part wrapper for a
GPS unit or a data scientist that can write an recursive neural net autopilot?
If so please write a part so other people driving donkeys can use the part.

### Fix or report a bug.
If you find a problem with the code and you know how to fix it then please
clone the repo, make your fix, and submit your pull request.

### Reply to issues.
Helping close or triage the issues is a good way to help.


### Need Inspiration?
Search the code or docs for `TODO` to find places where you might be able 
to find a better solution. 

### Improve the documentation.
You can fix grammar or provide clarity by clicking the the *Edit on GitHub* 
link in the top right corner.
